unit nMail;

interface

uses WinSock;

{$IFDEF VER90}
type
  TSocket = Integer;
{$ENDIF}

const
{$IFDEF VER90}
  INVALID_SOCKET = TSocket(NOT(0));
{$ENDIF}
  NMAIL_ATTACHMENT_TEMP_SIZE = 400;

  NMAIL_ERROR_SOCKET = -1;
  NMAIL_ERROR_AUTHENTICATE = -2;
  NMAIL_ERROR_INVALID_NO = -3;
  NMAIL_ERROR_TIMEOUT = -4;
  NMAIL_ERROR_FILE_OPEN = -5;
  NMAIL_ERROR_PARTIAL = -6;
  NMAIL_ERROR_FILE_ALREADY = -7;
  NMAIL_ERROR = -10;

  NMAIL_ERROR_SUSPEND_ATTACHMENT_FILE = -20;

  NMAIL_ERROR_SERVICE_NOT_AVAILABLE = -421;
  NMAIL_ERROR_MAILBOX_UNAVAILABLE = -450;
  NMAIL_ERROR_LOCAL_ERROR = -451;
  NMAIL_ERROR_INSUFFICIENT_SYSTEM_STORAGE = -452;
  NMAIL_ERROR_SYNTAX_ERROR = -500;
  NMAIL_ERROR_PARAMETER = -501;
  NMAIL_ERROR_COMMAND_NOT_IMPLEMENTED = -502;
  NMAIL_ERROR_BAD_SEQUENCE = -503;
  NMAIL_ERROR_USER_UNKOWN = -550;
  NMAIL_ERROR_USER_NOT_LOCAL = -551;
  NMAIL_ERROR_EXCEEDED_STORAGE_ALLOCATION = -552;
  NMAIL_ERROR_MAILBOX_NAME_NOT_ALLOWED = -553;
  NMAIL_ERROR_RELAY_OPERATION_REJECTED = -553;
  NMAIL_ERROR_TRANSACTION_FAILED = -554;

  NMAIL_NO_ATTACHMENT_FILE = -1;
  NMAIL_ATTACHMENT_FILE = 0;

  NMAIL_SUCCESS = 1;

  NMAIL_PARTIAL_ATTACHMENT_FILE = 1;
  NMAIL_GET_TEXT_ONLY = 2;

  NMAIL_ADD_DATE_FIELD = 1;
  NMAIL_ADD_MESSAGEID_FIELD = 2;
  NMAIL_SUSPEND_ATTACHMENT_FILE = 4;
  NMAIL_SUSPEND_NEXT = 8;

  NMAIL_OPTION_TIMEOUT = 0;
  NMAIL_OPTION_HEADER_MAX = 1;
  NMAIL_OPTION_BODY_MAX = 2;
  NMAIL_OPTION_ALREADY_FILE = 3;
  NMAIL_OPTION_DEBUG_MODE = 4;
  NMAIL_OPTION_CONNECT_TIMEOUT = 5;
  NMAIL_OPTION_SPLIT_CHAR = 6;
  NMAIL_OPTION_SUSPEND_SIZE = 7;

  NMAIL_FILE_OVERWRITE = 0;
  NMAIL_FILE_RENAME = 1;
  NMAIL_FILE_ALREADY_ERROR = 2;

  NMAIL_GET_ERROR_MESSAGE = 0;
  NMAIL_GET_DEBUG_MESSAGE = 1;

  NMAIL_DEBUG_START = 1;
  NMAIL_DEBUG_END = 0;

  NMAIL_GET_UIDL_ALL = 0;

  NMAIL_CONNECT_TIMEOUT_ON = 1;
  NMAIL_CONNECT_TIMEOUT_OFF = 2;

  NMAIL_SMTP_AUTH_NOT_USE = 0;
  NMAIL_SMTP_AUTH_PLAIN = 1;
  NMAIL_SMTP_AUTH_LOGIN = 2;
  NMAIL_SMTP_AUTH_CRAM_MD5 = 4;

function NMailGetVersion: Integer; export; stdcall; External 'nMail.dll';
procedure NMailSetParameter(TimeOutSec: Integer; HeaderMax: Integer; BodyMax: Integer); export; stdcall; External 'nMail.dll';
function NMailInitializeWinSock: LongBool; export; stdcall; External 'nMail.dll';
function NMailEndWinSock: LongBool; export; stdcall; External 'nMail.dll';
function NMailPop3Connect(HostName: PChar): TSocket; export; stdcall; External 'nMail.dll';
function NMailPop3ConnectPortNo(HostName: PChar; PortNo: Integer): TSocket; export; stdcall; External 'nMail.dll';
function NMailPop3Authenticate(S: TSocket; ID: PChar; Password: PChar; APopFlag: LongBool): Integer; export; stdcall; External 'nMail.dll';
function NMailPop3Close(S: TSocket): Integer; export; stdcall; External 'nMail.dll';
function NMailPop3GetMailSize(S: TSocket; No: Integer): Integer; export; stdcall; External 'nMail.dll';
function NMailPop3GetMailStatus(S: TSocket; No: Integer; Subject: PChar; Date: PChar; From: PChar; Header: PChar; SizeFlag: LongBool): Integer; export; stdcall; External 'nMail.dll';
function NMailPop3GetMail(S: TSocket; No: Integer; Subject: PChar; Date: PChar; From: PChar; Header: PChar; Body: PChar; Path: PChar; FileName: PChar): Integer; export; stdcall; External 'nMail.dll';
function NMailPop3GetMailEx(S: TSocket; No: Integer; Subject: PChar; Date: PChar; From: PChar; Header: PChar; Body: PChar; Path: PChar; FileName: PChar; Temp: PChar; Flag: Integer): Integer; export; stdcall; External 'nMail.dll';
function NMailPop3GetMailPartial(S: TSocket; No: Integer; Subject: PChar; Date: PChar; From: PChar; Header: PChar; Body: PChar; Path: PChar; FileName: PChar): Integer; export; stdcall; External 'nMail.dll';
function NMailPop3GetAttachmentFileStatus(S: TSocket; No: Integer; Id: PChar; Max: Integer): Integer; export; stdcall; External 'nMail.dll';
function NMailPop3DeleteMail(S: TSocket; No: Integer): Integer; export; stdcall; External 'nMail.dll';
function NMailPop3GetUidl(Socket: TSocket; No: Integer; Uidl: PChar; Max: Integer): Integer; export; stdcall; External 'nMail.dll';
function NMailSmtpSendMail(HostName: PChar; MailTo: PChar; Cc: PChar; Bcc: PChar; From: PChar; Subject: PChar; Body: PChar; Header: PChar; Path: PChar; Flag: Integer): Integer; export; stdcall; External 'nMail.dll';
function NMailSmtpSendMailPortNo(HostName: PChar; MailTo: PChar; Cc: PChar; Bcc: PChar; From: PChar; Subject: PChar; Body: PChar; Header: PChar; Path: PChar; Flag: Integer; PortNo: Integer): Integer; export; stdcall; External 'nMail.dll';
function NMailSmtpConnect(HostName: PChar): TSocket; export; stdcall; External 'nMail.dll';
function NMailSmtpConnectPortNo(HostName: PChar; PortNo: Integer): TSocket; export; stdcall; External 'nMail.dll';
function NMailSmtpAuthenticate(S: TSocket; HostName: PChar; ID: PChar; Password: PChar; Mode: Integer): Integer; export; stdcall; External 'nMail.dll';
function NMailSmtpSendMailEx(S: TSocket; MailTo: PChar; Cc: PChar; Bcc: PChar; From: PChar; Subject: PChar; Body: PChar; Header: PChar; Path: PChar; Temp: PChar; Flag: Integer): Integer; export; stdcall; External 'nMail.dll';
function NMailSmtpClose(S: TSocket): Integer; export; stdcall; External 'nMail.dll';
function NMailGetHeaderField(Field: PChar; Header: PChar; Name: PChar; Size: Integer): LongBool; export; stdcall; External 'nMail.dll';
function NMailAttachmentFileFirst(Temp: PChar; Subject: PChar; Date: PChar; From: PChar; Header: PChar; Body: PChar; Path: PChar; FileName: PChar; FirstHeader: PChar; FirstBody: PChar):Integer; export; stdcall; External 'nMail.dll';
function NMailAttachmentFileNext(Temp: PChar; NextHeader: PChar; NextBody: PChar): Integer; export; stdcall; External 'nMail.dll';
function NMailAttachmentFileClose(Temp: PChar): Integer; export; stdcall; External 'nMail.dll';
function NMailAttachmentFileStatus(Header: PChar; Id: PChar; Max: Integer): Integer; export; stdcall; External 'nMail.dll';
function NMailSetOption(Option: Integer; Value: Integer): LongBool; export; stdcall; External 'nMail.dll';
function NMailGetOption(Option: Integer): Integer; export; stdcall; External 'nMail.dll';
procedure NMailGetMessage(MType: Integer; Msg: PChar; Size: Integer); export; stdcall; External 'nMail.dll';
function NMailGetSuspendNumber(Path: PChar): Integer; export; stdcall; External 'nMail.dll';

implementation

end.
