unit testmain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Winsock, ExtCtrls, ComCtrls, Menus, IniFiles;

type
  TMainForm = class(TForm)
    MailListView: TListView;
    Splitter1: TSplitter;
    BodyMemo: TMemo;
    MainMenu: TMainMenu;
    File1: TMenuItem;
    mCreate: TMenuItem;
    N1: TMenuItem;
    mExit: TMenuItem;
    S1: TMenuItem;
    mSetting: TMenuItem;
    N2: TMenuItem;
    mDelete: TMenuItem;
    PopupMenu: TPopupMenu;
    mPopupReply: TMenuItem;
    N3: TMenuItem;
    mPopupDelete: TMenuItem;
    mReply: TMenuItem;
    N4: TMenuItem;
    mRenewal: TMenuItem;
    mSave: TMenuItem;
    N5: TMenuItem;
    SaveDialog: TSaveDialog;
    mAttachment: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MailListViewClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure mCreateClick(Sender: TObject);
    procedure mExitClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure mSettingClick(Sender: TObject);
    procedure MailListViewMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mDeleteClick(Sender: TObject);
    procedure mPopupReplyClickClick(Sender: TObject);
    procedure mRenewalClick(Sender: TObject);
    procedure mSaveClick(Sender: TObject);
    procedure mAttachmentClick(Sender: TObject);
  private
    { Private 錾 }
    S: TSocket;       // \Pbg
    Id: String;       // ID
    Password: String; // pX[h
    Pop3Name: String; // POP3T[o[
    APopFlag: Boolean; // APOP gp邩
    procedure AddMailList(S: TSocket);  // 薼ꗗListViewɕ\
	procedure HeaderDataClear;
  public
    { Public 錾 }
    SmtpName: String;    // SMTPT[o[
    MailAddress: String; // [AhX
  end;

const
  OptionSection = 'DPMAIL';
  OptionApopFlag = 'ApopFlag';
  OptionSmtpName = 'SmtpName';
  OptionPop3Name = 'Pop3Name';
  OptionMailAddress = 'MailAddress';

  HEADER_MAX = 8192;

var
  MainForm: TMainForm;

implementation

uses nMail, Input, write, Option, unite;

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
var
  W: integer;
  IniFileName: TFileName;
  IniFile: TIniFile;
begin
    // dpmail.ini ݒǂݍ
    IniFileName := ChangeFileExt(Application.ExeName, '.INI');
    IniFile := TIniFile.Create(IniFileName);
    try
        with IniFile do
        begin
            APopFlag := ReadBool(OptionSection, OptionApopFlag, False);
            SmtpName := ReadString(OptionSection, OptionSmtpName, '');
            Pop3Name := ReadString(OptionSection, OptionPop3Name, '');
            MailAddress := ReadString(OptionSection, OptionMailAddress, '');
        end;
        finally
            IniFile.Free;
    end;
    // ListView ̍ڕݒ
    W := MailListView.ClientWidth;
    MailListView.Columns[0].Width := W div 2;
    MailListView.Columns[1].Width := W div 4;
	MailListView.Columns[2].Width := W div 4;

    // Winsock 
    NMailInitializeWinSock;

    // ^CAEg̓ftHg(30b)
    // wb_ől 8192
    // {ől͖
    NMailSetParameter(0, HEADER_MAX, 0);

    // \Pbgϐ
    S := INVALID_SOCKET;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    // Winsock gpI
    NMailEndWinsock;
end;

procedure TMainForm.MailListViewClick(Sender: TObject);
var
  Subject: array [0..HEADER_MAX] of Char;
  Date: array [0..HEADER_MAX] of Char;
  From: array [0..HEADER_MAX] of Char;
fname: array [0..header_max] of char;
  Header: array [0..HEADER_MAX] of Char;
  Body: PChar;
  Size: Integer;
begin
	mSave.Enabled := False;
	mReply.Enabled := False;
    with MailListView do
    begin
        // IĂ邩H
        if SelCount > 0 then
        begin
            // Ă킩܂AM̂тɐڑĂ܂B
            // {ł ID pX[h͌AxɎMA
            // T[o[ォM[폜At@C
            // ۑĂA薼ꗗNbNł́AۑĂ郁[
            // ǂݍޏׂł傤B

            // POP3 T[o[ɐڑ
            S := NMailPop3Connect(PChar(Pop3Name));
            if S <> INVALID_SOCKET then
            begin
                // IĂԍA[̐菭ȂH
                if Selected.Index < NMailPop3Authenticate(S, PChar(Id), PChar(Password), ApopFlag) then
                begin
                    // [̃TCY𓾂āAm
                    Size := NMailPop3GetMailSize(S, Selected.Index + 1);
                    GetMem(Body, Size);
                    // [ǂݍ
                    NMailPop3GetMail(S, Selected.Index + 1, subject, date, from, header, Body, nil, nil);
                    // \p Memo NAĎMeǉB
                    BodyMemo.Lines.Clear;
                    BodyMemo.Lines.Add(Strpas(Body));
                    // J[\擪Ɉړ
                    BodyMemo.SelStart := 0;
                    BodyMemo.SelLength := 0;
                    // mۂJ
                    FreeMem(Body);
                end;
            end;
            // ڑI
            NMailPop3Close(S);
            S := INVALID_SOCKET;

			mSave.Enabled := True;
			mReply.Enabled := True;
		end;
    end;
end;

procedure TMainForm.HeaderDataClear;
var
  No: Integer;
begin
	for No := 0 to MailListView.Items.Count - 1 do
	begin
		FreeMem(MailListView.Items[No].Data);
	end;
end;

procedure TMainForm.AddMailList(S: TSocket);
var
  No, Count: integer;
  Subject: array [0..HEADER_MAX] of Char;
  Date: array [0..HEADER_MAX] of Char;
  From: array [0..HEADER_MAX] of Char;
  Header: PChar;
  Msg: String;
  I: TListItem;
begin
    // [{\NA
    BodyMemo.Lines.Clear;
    // ListView NA
	HeaderDataClear;
    MailListView.Items.Clear;
    // POP3 T[oɐڑ
    S := NMailPop3Connect(PChar(Pop3Name));
    if S <> INVALID_SOCKET then
    begin
        if (Id = '') or (Password = '') then
        begin
           // ID ƃpX[h
           if InputForm.ShowModal = mrOk then
           begin
                Id := InputForm.IdEdit.Text;
                Password := InputForm.PasswordEdit.Text;
           end;
        end;
        // [̐𓾂
        No := NMailPop3Authenticate(S, PChar(Id), PChar(Password), ApopFlag);
        if No >= 0 then
        begin
            for Count := 1 to No do
            begin
				GetMem(Header, HEADER_MAX);
                // ԂɃwb_̓eǂ݁AListView ɒǉ
                NMailPop3GetMailStatus(S, Count, Subject, Date, From, Header, False);
                I := MailListView.Items.Add;
                I.Caption := StrPas(Subject);
                I.SubItems.Add(StrPas(Date));
                I.SubItems.Add(StrPas(From));
				I.Data := Header;
				StrLCat(Header, #13#10, HEADER_MAX - 1);
            end;
        end
        else
		begin
			NMailGetMessage(NMAIL_GET_ERROR_MESSAGE, Subject, HEADER_MAX);
			Msg := 'OCł܂ł' + #13#10 + StrPas(Subject) + ' ' + IntToStr(No);
            MessageDlg(Msg, mtError, [mbOk], 0);
            Id := '';
            Password := '';
		end;
        NMailPop3Close(S);
        S := INVALID_SOCKET;
    end;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
    if S = INVALID_SOCKET then
    begin
        // ݒ肪ĂȂꍇ͐ݒ_CAO\
        if Pop3Name = '' then
            mSettingClick(Sender);

        // 薼ꗗǂݍ
        AddMailList(S);
    end;
end;

procedure TMainForm.mCreateClick(Sender: TObject);
var
  No, Ret: integer;
  Body: String;
  AttachPt: PChar;
S: TSocket;
begin
	// ͗NA
	WriteForm.ToEdit.Text := '';
	WriteForm.SubjectEdit.Text := '';
	// 2000/7/28
	WriteForm.AttachEdit.Text := '';
	WriteForm.BodyMemo.Lines.Clear;
    // [̈e
    if WriteForm.ShowModal = mrOk then
    begin
        // ͓e Body ɓ
        Body := '';
        for No := 0 to WriteForm.BodyMemo.Lines.Count - 1 do
            Body := Body + WriteForm.BodyMemo.Lines.Strings[No] + #13#10;

		if FileExists(WriteForm.AttachEdit.Text) then
			AttachPt := PChar(WriteForm.AttachEdit.Text)
        else
        	AttachPt := nil;
        // [M
        Ret := NMailSmtpSendMail(PChar(SmtpName), PChar(WriteForm.ToEdit.Text), nil, nil
                       , PChar(MailAddress), PChar(WriteForm.SubjectEdit.Text)
                       , PChar(Body), nil, PChar(WriteForm.AttachEdit.Text), 0);
        // MsH
        if Ret < 0 then
            MessageBox(Handle, 'Mł܂ł', 'G[', MB_OK);
    end;
end;

procedure TMainForm.mExitClick(Sender: TObject);
begin
    Close;
end;

procedure TMainForm.FormResize(Sender: TObject);
var
    W: integer;
begin
    // Form ̃TCYύXŁAListView ̍ڕύX
    W := MailListView.ClientWidth;
    MailListView.Columns[0].Width := W div 2;
    MailListView.Columns[1].Width := W div 4;
    MailListView.Columns[2].Width := W div 4;
end;

procedure TMainForm.mSettingClick(Sender: TObject);
var
  IniFileName: TFileName;
  IniFile: TIniFile;
begin
    // ݒ_CAOɐݒeZbg
    OptionForm.SmtpEdit.Text := SmtpName;
    OptionForm.Pop3Edit.Text := Pop3Name;
    OptionForm.MailEdit.text := MailAddress;
    OptionForm.APopCheck.Checked := APopFlag;
    if OptionForm.ShowModal = mrOk then
    begin
        // ݒeXV
        SmtpName := OptionForm.SmtpEdit.Text;
        Pop3Name := OptionForm.Pop3Edit.Text;
        MailAddress := OptionForm.MailEdit.Text;
        APopFlag := OptionForm.APopCheck.Checked;
        // dpmail.ini ɐݒeۑ
        IniFileName := ChangeFileExt(Application.ExeName, '.INI');
        IniFile := TIniFile.Create(IniFileName);
        try
            with IniFile do
            begin
                WriteBool(OptionSection, OptionApopFlag, APopFlag);
                WriteString(OptionSection, OptionSmtpName, SmtpName);
                WriteString(OptionSection, OptionPop3Name, Pop3Name);
                WriteString(OptionSection, OptionMailAddress, MailAddress);
            end;
        finally
            IniFile.Free;
        end;
    end;
end;

procedure TMainForm.MailListViewMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
    // ENbNȂ|bvAbvj[\
    if Button = mbRight then
    begin
        with ClientToScreen(Point(X, Y)) do
            PopupMenu.Popup(X, Y);
    end;
end;

procedure TMainForm.mDeleteClick(Sender: TObject);
begin
    with MailListView do
    begin
        // IĂ邩H
        if SelCount > 0 then
        begin
            // POP3 T[o[ɐڑ
            S := NMailPop3Connect(PChar(Pop3Name));
            if S <> INVALID_SOCKET then
            begin
                // [IԍH
                if Selected.Index < NMailPop3Authenticate(S, PChar(Id), PChar(Password), ApopFlag) then
                    // [폜
                    NMailPop3DeleteMail(S, Selected.Index + 1);
                // ڑI
                NMailPop3Close(S);
            end;
        end;
    end;
    // 薼ꗗ\
    AddMailList(S);
end;

procedure TMainForm.mPopupReplyClickClick(Sender: TObject);
var
  No, Ret: Integer;
  Body: String;
  Temp: array [0..HEADER_MAX] of Char;
begin
    with MailListView do
    begin
        // IĂ邩H
        if SelCount > 0 then
        begin
            // 2000/5/22
            // ɂɍol Reply-To Ă
			if NMailGetHeaderField(Temp, Selected.Data, 'Reply-To:', HEADER_MAX) then
                WriteForm.ToEdit.Text := StrPas(Temp)
            else
                WriteForm.ToEdit.Text := Selected.SubItems[1];
			//  Re: ēĂ
			if NMailGetHeaderField(Temp, Selected.Data, 'Subject:', HEADER_MAX) then
				WriteForm.SubjectEdit.Text := 'Re: ' + Temp
			else
				WriteForm.SubjectEdit.Text := '';
			WriteForm.BodyMemo.Lines.Clear;
            // [̈e
            if WriteForm.ShowModal = mrOk then
            begin
             	// ͓e Body ɓ
             	Body := '';
             	for No := 0 to WriteForm.BodyMemo.Lines.Count - 1 do
                	Body := Body + WriteForm.BodyMemo.Lines.Strings[No] + #13#10;

                // [M
                Ret := NMailSmtpSendMail(PChar(SmtpName), PChar(WriteForm.ToEdit.Text), nil, nil
                	, PChar(MailAddress), PChar(WriteForm.SubjectEdit.Text)
                    , PChar(Body)
                    , 'Content-Type: multipart/mixed; boundary="----=_NextPart_000_0002_01C0346E.34EE4010'
                    , nil, 0);

                // MsH
                if Ret < 0 then
                	MessageBox(Handle, 'Mł܂ł', 'G[', MB_OK);
            end;
        end;
    end;
end;

procedure TMainForm.mRenewalClick(Sender: TObject);
begin
    // 薼ꗗ\
    AddMailList(S);
end;

procedure TMainForm.mSaveClick(Sender: TObject);
var
	Fs: TFileStream;
begin
    if MailListView.Selected <> nil then
	begin
		// [eLXgt@Cɕۑ
 		if SaveDialog.Execute then
		begin
			Fs := TFileStream.Create(SaveDialog.FileName, fmCreate);
			// wb_ۑ
			Fs.WriteBuffer(MailListView.Selected.Data^, StrLen(PChar(MailListView.Selected.Data)));
			// [{ۑ
			BodyMemo.Lines.SaveToStream(Fs);
			Fs.Free;
		end;
	end;
end;

procedure TMainForm.mAttachmentClick(Sender: TObject);
begin
	// WJۑp̃_CAO\
	UniteForm.ShowModal;
end;

end.
